Wt: Wt::WFitLayout Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | List of all members
Wt::WFitLayout Class Reference

A layout manager which spans a single widget to all available space. More...

`#include <Wt/WFitLayout.h>`

Inheritance diagram for Wt::WFitLayout:
[legend]

## Public Member Functions
| WFitLayout ()
| Creates a new fit layout.
template<typename Widget >
Widget * | addWidget (std::unique_ptr< Widget > widget)
| Adds a widget to the layout, returning a raw pointer.
virtual void | addItem (std::unique_ptr< WLayoutItem > item) override
| Adds a layout item.
virtual std::unique_ptr< WLayoutItem > | removeItem (WLayoutItem *item) override
| Removes a layout item (widget or nested layout).
virtual WLayoutItem * | itemAt (int index) const override
| Returns the layout item at a specific index.
virtual int | indexOf (WLayoutItem *item) const override
| Returns the index of a given item.
virtual int | count () const override
| Returns the number of items in this layout.
Public Member Functions inherited from Wt::WLayout
virtual | ~WLayout ()
| Destructor.
void | setPreferredImplementation (LayoutImplementation implementation)
| Set the preferred layout implementation.
void | addWidget (std::unique_ptr< WWidget > widget)
| Adds the given widget to the layout.
std::unique_ptr< WWidget > | removeWidget (WWidget *widget)
| Removes the given widget from the layout.
virtual WWidgetItem * | findWidgetItem (WWidget *widget) override
| Finds the widget item associated with the given widget.
virtual WWidget * | widget () override
| Returns the widget that is held by this WLayoutItem.
virtual WLayout * | layout () override
| Returns the layout that implements this WLayoutItem.
virtual WLayout * | parentLayout () const override
| Returns the layout in which this item is contained.
void | setContentsMargins (int left, int top, int right, int bottom)
| Set contents margins (in pixels).
void | getContentsMargins (int *left, int *top, int *right, int *bottom) const
| Returns the contents margins.
Public Member Functions inherited from Wt::WLayoutItem
virtual | ~WLayoutItem ()
| Destructor.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
virtual const std::string | id () const
| Returns the (unique) identifier for this object.
virtual void | setObjectName (const std::string &name)
| Sets an object name.
virtual std::string | objectName () const
| Returns the object name.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Private Member Functions
virtual void | setParentWidget (WWidget *parent) override
| Internal method.

## Additional Inherited Members
Public Types inherited from Wt::WLayoutItem
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WLayout
static void | setDefaultImplementation (LayoutImplementation implementation)
| Sets the preferred layout implementation globally.
Static Public Member Functions inherited from Wt::WObject
Protected Member Functions inherited from Wt::WLayout
| WLayout ()
| Create a layout.
void | update (WLayoutItem *item=nullptr)
| Update the layout.
Protected Member Functions inherited from Wt::WObject
virtual WStatelessSlot * | getStateless (Method method)
| On-demand stateless slot implementation.

## Detailed Description

A layout manager which spans a single widget to all available space.

This layout manager may manage only a single child widget, and sizes that widget so that it uses all space available in the parent.

## Member Function Documentation

## ◆ addItem()

virtual void Wt::WFitLayout::addItem | ( | std::unique_ptr< WLayoutItem > | item | ) |
| overridevirtual

Adds a layout item.

The item may be a widget or nested layout.

How the item is layed out with respect to siblings is implementation specific to the layout manager. In some cases, a layout manager will overload this method with extra arguments that specify layout options.

See also
  removeItem(WLayoutItem *), addWidget(WWidget *)

Implements Wt::WLayout.

## ◆ addWidget()

template<typename Widget >

Widget * Wt::WFitLayout::addWidget | ( | std::unique_ptr< Widget > | widget | ) |

Adds a widget to the layout, returning a raw pointer.

This is implemented as:

Widget *result = widget.get();
WLayout::addWidget(std::unique_ptr<WWidget>(std::move(widget)));
return result;
Wt::WLayout::addWidget
void addWidget(std::unique_ptr< WWidget > widget)
Adds the given widget to the layout.
Wt::WLayout::widget
virtual WWidget * widget() override
Returns the widget that is held by this WLayoutItem.
Definition WLayout.h:161

## ◆ count()

virtual int Wt::WFitLayout::count | ( |  | ) | const
| overridevirtual

Returns the number of items in this layout.

This may be a theoretical number, which is greater than the actual number of items. It can be used to iterate over the items in the layout, in conjunction with itemAt().

Implements Wt::WLayout.

## ◆ indexOf()

virtual int Wt::WFitLayout::indexOf | ( | WLayoutItem * | item | ) | const
| overridevirtual

Returns the index of a given item.

The default implementation loops over all items, and returns the index for which itemAt(index) equals `item`.

See also
  itemAt(int) const

Reimplemented from Wt::WLayout.

## ◆ itemAt()

virtual WLayoutItem * Wt::WFitLayout::itemAt | ( | int | index | ) | const
| overridevirtual

Returns the layout item at a specific index.

If there is no item at the `index`, `0` is returned.

See also
  indexOf(WLayoutItem *) const, count()

Implements Wt::WLayout.

## ◆ removeItem()

virtual std::unique_ptr< WLayoutItem > Wt::WFitLayout::removeItem | ( | WLayoutItem * | item | ) |
| overridevirtual

Removes a layout item (widget or nested layout).

See also
  addItem(WLayoutItem *), removeWidget(WWidget *)

Implements Wt::WLayout.